﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.3),
    on Tue Jul 26 22:17:54 2022
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.3'
expName = 'TouchCat'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/Users/brookejac55/Desktop/TouchCat/TouchCat2_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1440, 900], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}
ioSession = ioServer = eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='event')

# Initialize components for Routine "trials_2"
trials_2Clock = core.Clock()
Task_Stim = visual.ImageStim(
    win=win,
    name='Task_Stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.2, 1),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
A_rect = visual.Rect(
    win=win, name='A_rect',
    width=(0.1, 0.15)[0], height=(0.1, 0.15)[1],
    ori=0.0, pos=(-0.28, -.3), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='yellow',
    opacity=None, depth=-1.0, interpolate=True)
B_rect = visual.Rect(
    win=win, name='B_rect',
    width=(0.1, 0.15)[0], height=(0.1, 0.15)[1],
    ori=0.0, pos=(0.3, -.3), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='yellow',
    opacity=None, depth=-2.0, interpolate=True)
mouse = event.Mouse(win=win)
x, y = [None, None]
mouse.mouseClock = core.Clock()
mouserec=mouse.getPos()
minRT=.2
Resp = ''

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# set up handler to look after randomisation of conditions etc
task_loop = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Task_List.xlsx'),
    seed=None, name='task_loop')
thisExp.addLoop(task_loop)  # add the loop to the experiment
thisTask_loop = task_loop.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTask_loop.rgb)
if thisTask_loop != None:
    for paramName in thisTask_loop:
        exec('{} = thisTask_loop[paramName]'.format(paramName))

for thisTask_loop in task_loop:
    currentLoop = task_loop
    # abbreviate parameter names if possible (e.g. rgb = thisTask_loop.rgb)
    if thisTask_loop != None:
        for paramName in thisTask_loop:
            exec('{} = thisTask_loop[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "trials_2"-------
    continueRoutine = True
    # update component parameters for each repeat
    Task_Stim.setImage(Stim)
    # setup some python lists for storing info about the mouse
    mouse.x = []
    mouse.y = []
    mouse.leftButton = []
    mouse.midButton = []
    mouse.rightButton = []
    mouse.time = []
    mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    trials_2Components = [Task_Stim, A_rect, B_rect, mouse]
    for thisComponent in trials_2Components:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    trials_2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "trials_2"-------
    while continueRoutine:
        # get current time
        t = trials_2Clock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=trials_2Clock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *Task_Stim* updates
        if Task_Stim.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            Task_Stim.frameNStart = frameN  # exact frame index
            Task_Stim.tStart = t  # local t and not account for scr refresh
            Task_Stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(Task_Stim, 'tStartRefresh')  # time at next scr refresh
            Task_Stim.setAutoDraw(True)
        
        # *A_rect* updates
        if A_rect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            A_rect.frameNStart = frameN  # exact frame index
            A_rect.tStart = t  # local t and not account for scr refresh
            A_rect.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(A_rect, 'tStartRefresh')  # time at next scr refresh
            A_rect.setAutoDraw(True)
        
        # *B_rect* updates
        if B_rect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            B_rect.frameNStart = frameN  # exact frame index
            B_rect.tStart = t  # local t and not account for scr refresh
            B_rect.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(B_rect, 'tStartRefresh')  # time at next scr refresh
            B_rect.setAutoDraw(True)
        # *mouse* updates
        if mouse.status == NOT_STARTED and t >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            mouse.frameNStart = frameN  # exact frame index
            mouse.tStart = t  # local t and not account for scr refresh
            mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(mouse, 'tStartRefresh')  # time at next scr refresh
            mouse.status = STARTED
            mouse.mouseClock.reset()
            prevButtonState = mouse.getPressed()  # if button is down already this ISN'T a new click
        if mouse.status == STARTED:  # only update if started and not finished!
            buttons = mouse.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter([A_rect, B_rect])
                        clickableList = [A_rect, B_rect]
                    except:
                        clickableList = [[A_rect, B_rect]]
                    for obj in clickableList:
                        if obj.contains(mouse):
                            gotValidClick = True
                            mouse.clicked_name.append(obj.name)
                    x, y = mouse.getPos()
                    mouse.x.append(x)
                    mouse.y.append(y)
                    buttons = mouse.getPressed()
                    mouse.leftButton.append(buttons[0])
                    mouse.midButton.append(buttons[1])
                    mouse.rightButton.append(buttons[2])
                    mouse.time.append(mouse.mouseClock.getTime())
                    if gotValidClick:
                        continueRoutine = False  # abort routine on response
        mouseloc=mouse.getPos()
        if mouseloc[0]==mouserec[0] and mouseloc[1]==mouserec[1]:
            pass
        elif B_rect.contains(mouse):
            if t>minRT:
                Resp = 'B'
                continueRoutine=False
        elif A_rect.contains(mouse):
            if t>minRT:
                Resp = 'A'
                continueRoutine=False
            else:
                mousered=mouse.getPos()
                
        thisExp.addData('AB_Resp_Chosen',Resp)
        
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trials_2Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trials_2"-------
    for thisComponent in trials_2Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    task_loop.addData('Task_Stim.started', Task_Stim.tStartRefresh)
    task_loop.addData('Task_Stim.stopped', Task_Stim.tStopRefresh)
    task_loop.addData('A_rect.started', A_rect.tStartRefresh)
    task_loop.addData('A_rect.stopped', A_rect.tStopRefresh)
    task_loop.addData('B_rect.started', B_rect.tStartRefresh)
    task_loop.addData('B_rect.stopped', B_rect.tStopRefresh)
    # store data for task_loop (TrialHandler)
    task_loop.addData('mouse.x', mouse.x)
    task_loop.addData('mouse.y', mouse.y)
    task_loop.addData('mouse.leftButton', mouse.leftButton)
    task_loop.addData('mouse.midButton', mouse.midButton)
    task_loop.addData('mouse.rightButton', mouse.rightButton)
    task_loop.addData('mouse.time', mouse.time)
    task_loop.addData('mouse.clicked_name', mouse.clicked_name)
    task_loop.addData('mouse.started', mouse.tStart)
    task_loop.addData('mouse.stopped', mouse.tStop)
    # the Routine "trials_2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'task_loop'


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
